package ru.dbotthepony.mc.otm.menu.matter

import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.matter.MatterDecomposerBlockEntity
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.container.slotted.SlottedContainer
import ru.dbotthepony.mc.otm.matter.MatterManager
import ru.dbotthepony.mc.otm.menu.OutputMenuSlot
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.UserFilteredMenuSlot
import ru.dbotthepony.mc.otm.menu.input.EnergyConfigPlayerInput
import ru.dbotthepony.mc.otm.menu.input.ItemConfigPlayerInput
import ru.dbotthepony.mc.otm.menu.makeUpgradeSlots
import ru.dbotthepony.mc.otm.menu.widget.ProfiledLevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.game.MMenus

class MatterDecomposerMenu(
	containerID: Int,
	inventory: Inventory,
	tile: MatterDecomposerBlockEntity? = null
) : MatteryPoweredMenu(MMenus.MATTER_DECOMPOSER, containerID, inventory, tile) {
	val input = object : UserFilteredMenuSlot(tile?.inputContainer ?: SlottedContainer.filtered(1), 0) {
		override fun mayPlace(itemStack: ItemStack) = MatterManager.canDecompose(itemStack)
	}

	val outputMain: OutputMenuSlot
	val outputStacking: OutputMenuSlot
	val progressWidget = ProgressGaugeWidget(this, tile)
	val matterWidget = ProfiledLevelGaugeWidget(this, tile?.matter, LevelGaugeWidget(this, tile?.matter))
	val itemConfig = ItemConfigPlayerInput(this, tile?.itemConfig)
	val energyConfig = EnergyConfigPlayerInput(this, tile?.energyConfig)
	val profiledEnergy = ProfiledLevelGaugeWidget(this, tile?.energy, energyWidget)
	val upgrades = makeUpgradeSlots(4, tile?.upgrades)

	init {
		val container = tile?.outputContainer ?: SlottedContainer.simple(2)

		// Выход
		outputMain = OutputMenuSlot(container, 0)
		outputStacking = OutputMenuSlot(container, 1)

		addStorageSlot(outputMain)
		addStorageSlot(outputStacking)
		addStorageSlot(input)

		addInventorySlots()
	}
}
